diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/rip.cc ns-3.31/src/internet/model/rip.cc
--- ns-3.30.1/src/internet/model/rip.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/rip.cc	2020-06-27 17:38:30.000000000 -0700
@@ -147,8 +147,12 @@
               socket->BindToNetDevice (m_ipv4->GetNetDevice (i));
               int ret = socket->Bind (local);
               NS_ASSERT_MSG (ret == 0, "Bind unsuccessful");
+
+              socket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
               socket->SetIpRecvTtl (true);
-              m_sendSocketList[socket] = i;
+              socket->SetRecvPktInfo (true);
+
+              m_unicastSocketList[socket] = i;
             }
           else if (m_ipv4->GetAddress (i, j).GetScope() == Ipv4InterfaceAddress::GLOBAL)
             {
@@ -157,17 +161,17 @@
         }
     }
 
-  if (!m_recvSocket)
+  if (!m_multicastRecvSocket)
     {
       NS_LOG_LOGIC ("RIP: adding receiving socket");
       TypeId tid = TypeId::LookupByName ("ns3::UdpSocketFactory");
       Ptr<Node> theNode = GetObject<Node> ();
-      m_recvSocket = Socket::CreateSocket (theNode, tid);
+      m_multicastRecvSocket = Socket::CreateSocket (theNode, tid);
       InetSocketAddress local = InetSocketAddress (RIP_ALL_NODE, RIP_PORT);
-      m_recvSocket->Bind (local);
-      m_recvSocket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
-      m_recvSocket->SetIpRecvTtl (true);
-      m_recvSocket->SetRecvPktInfo (true);
+      m_multicastRecvSocket->Bind (local);
+      m_multicastRecvSocket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
+      m_multicastRecvSocket->SetIpRecvTtl (true);
+      m_multicastRecvSocket->SetRecvPktInfo (true);
     }
 
 
@@ -316,7 +320,7 @@
 
 
   bool sendSocketFound = false;
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       if (iter->second == i)
         {
@@ -345,26 +349,28 @@
           InetSocketAddress local = InetSocketAddress (address.GetLocal (), RIP_PORT);
           socket->BindToNetDevice (m_ipv4->GetNetDevice (i));
           socket->Bind (local);
+          socket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
           socket->SetIpRecvTtl (true);
-          m_sendSocketList[socket] = i;
-        }
+          socket->SetRecvPktInfo (true);
+          m_unicastSocketList[socket] = i;
+       }
       if (address.GetScope () == Ipv4InterfaceAddress::GLOBAL)
         {
           SendTriggeredRouteUpdate ();
         }
     }
 
-  if (!m_recvSocket)
+  if (!m_multicastRecvSocket)
     {
       NS_LOG_LOGIC ("RIP: adding receiving socket");
       TypeId tid = TypeId::LookupByName ("ns3::UdpSocketFactory");
       Ptr<Node> theNode = GetObject<Node> ();
-      m_recvSocket = Socket::CreateSocket (theNode, tid);
+      m_multicastRecvSocket = Socket::CreateSocket (theNode, tid);
       InetSocketAddress local = InetSocketAddress (RIP_ALL_NODE, RIP_PORT);
-      m_recvSocket->Bind (local);
-      m_recvSocket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
-      m_recvSocket->SetIpRecvTtl (true);
-      m_recvSocket->SetRecvPktInfo (true);
+      m_multicastRecvSocket->Bind (local);
+      m_multicastRecvSocket->SetRecvCallback (MakeCallback (&Rip::Receive, this));
+      m_multicastRecvSocket->SetIpRecvTtl (true);
+      m_multicastRecvSocket->SetRecvPktInfo (true);
     }
 }
 
@@ -381,14 +387,14 @@
         }
     }
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       NS_LOG_INFO ("Checking socket for interface " << interface);
       if (iter->second == interface)
         {
           NS_LOG_INFO ("Removed socket for interface " << interface);
           iter->first->Close ();
-          m_sendSocketList.erase (iter);
+          m_unicastSocketList.erase (iter);
           break;
         }
     }
@@ -555,14 +561,14 @@
   m_nextTriggeredUpdate = EventId ();
   m_nextUnsolicitedUpdate = EventId ();
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       iter->first->Close ();
     }
-  m_sendSocketList.clear ();
+  m_unicastSocketList.clear ();
 
-  m_recvSocket->Close ();
-  m_recvSocket = 0;
+  m_multicastRecvSocket->Close ();
+  m_multicastRecvSocket = 0;
 
   m_ipv4 = 0;
 
@@ -714,11 +720,20 @@
   Address sender;
   Ptr<Packet> packet = socket->RecvFrom (sender);
   InetSocketAddress senderAddr = InetSocketAddress::ConvertFrom (sender);
-  NS_LOG_INFO ("Received " << *packet << " from " << senderAddr);
+  NS_LOG_INFO ("Received " << *packet << " from " << senderAddr.GetIpv4 () << ":" << senderAddr.GetPort ());
 
   Ipv4Address senderAddress = senderAddr.GetIpv4 ();
   uint16_t senderPort = senderAddr.GetPort ();
 
+  if (socket == m_multicastRecvSocket)
+    {
+      NS_LOG_LOGIC ("Received a packet from the multicast socket");
+    }
+  else
+    {
+      NS_LOG_LOGIC ("Received a packet from one of the unicast sockets");
+    }
+
   Ipv4PacketInfoTag interfaceInfo;
   if (!packet->RemovePacketTag (interfaceInfo))
     {
@@ -748,10 +763,12 @@
 
   if (hdr.GetCommand () == RipHeader::RESPONSE)
     {
+      NS_LOG_LOGIC ("The message is a Response from " << senderAddr.GetIpv4 () << ":" << senderAddr.GetPort ());
       HandleResponses (hdr, senderAddress, ipInterfaceIndex, hopLimit);
     }
   else if (hdr.GetCommand () == RipHeader::REQUEST)
     {
+      NS_LOG_LOGIC ("The message is a Request from " << senderAddr.GetIpv4 () << ":" << senderAddr.GetPort ());
       HandleRequests (hdr, senderAddress, senderPort, ipInterfaceIndex, hopLimit);
     }
   else
@@ -785,7 +802,7 @@
               // we use one of the sending sockets, as they're bound to the right interface
               // and the local address might be used on different interfaces.
               Ptr<Socket> sendingSocket;
-              for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+              for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
                 {
                   if (iter->second == incomingInterface)
                     {
@@ -918,7 +935,7 @@
         }
       p->AddHeader (hdr);
       NS_LOG_DEBUG ("SendTo: " << *p);
-      m_recvSocket->SendTo (p, 0, InetSocketAddress (senderAddress, senderPort));
+      m_multicastRecvSocket->SendTo (p, 0, InetSocketAddress (senderAddress, senderPort));
     }
 
 }
@@ -1067,7 +1084,7 @@
 {
   NS_LOG_FUNCTION (this << (periodic ? " periodic" : " triggered"));
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       uint32_t interface = iter->second;
 
@@ -1254,7 +1271,7 @@
   hdr.AddRte (rte);
   p->AddHeader (hdr);
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       uint32_t interface = iter->second;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/rip.h ns-3.31/src/internet/model/rip.h
--- ns-3.30.1/src/internet/model/rip.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/rip.h	2020-06-27 17:38:30.000000000 -0700
@@ -389,8 +389,8 @@
   /// Socket list type const iterator
   typedef std::map<Ptr<Socket>, uint32_t>::const_iterator SocketListCI;
 
-  SocketList m_sendSocketList; //!< list of sockets for sending (socket, interface index)
-  Ptr<Socket> m_recvSocket; //!< receive socket
+  SocketList m_unicastSocketList; //!< list of sockets for unicast messages (socket, interface index)
+  Ptr<Socket> m_multicastRecvSocket; //!< multicast receive socket
 
   EventId m_nextUnsolicitedUpdate; //!< Next Unsolicited Update event
   EventId m_nextTriggeredUpdate; //!< Next Triggered Update event
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ripng.cc ns-3.31/src/internet/model/ripng.cc
--- ns-3.30.1/src/internet/model/ripng.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ripng.cc	2020-06-27 17:38:30.000000000 -0700
@@ -141,9 +141,10 @@
               socket->BindToNetDevice (m_ipv6->GetNetDevice (i));
               int ret = socket->Bind (local);
               NS_ASSERT_MSG (ret == 0, "Bind unsuccessful");
-              socket->ShutdownRecv ();
+              socket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
               socket->SetIpv6RecvHopLimit (true);
-              m_sendSocketList[socket] = i;
+              socket->SetRecvPktInfo (true);
+              m_unicastSocketList[socket] = i;
             }
           else if (m_ipv6->GetAddress (i, j).GetScope() == Ipv6InterfaceAddress::GLOBAL)
             {
@@ -152,17 +153,17 @@
         }
     }
 
-  if (!m_recvSocket)
+  if (!m_multicastRecvSocket)
     {
       NS_LOG_LOGIC ("RIPng: adding receiving socket");
       TypeId tid = TypeId::LookupByName ("ns3::UdpSocketFactory");
       Ptr<Node> theNode = GetObject<Node> ();
-      m_recvSocket = Socket::CreateSocket (theNode, tid);
+      m_multicastRecvSocket = Socket::CreateSocket (theNode, tid);
       Inet6SocketAddress local = Inet6SocketAddress (RIPNG_ALL_NODE, RIPNG_PORT);
-      m_recvSocket->Bind (local);
-      m_recvSocket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
-      m_recvSocket->SetIpv6RecvHopLimit (true);
-      m_recvSocket->SetRecvPktInfo (true);
+      m_multicastRecvSocket->Bind (local);
+      m_multicastRecvSocket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
+      m_multicastRecvSocket->SetIpv6RecvHopLimit (true);
+      m_multicastRecvSocket->SetRecvPktInfo (true);
     }
 
 
@@ -287,7 +288,7 @@
 
 
   bool sendSocketFound = false;
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       if (iter->second == i)
         {
@@ -316,9 +317,10 @@
           Inet6SocketAddress local = Inet6SocketAddress (address.GetAddress (), RIPNG_PORT);
           socket->BindToNetDevice (m_ipv6->GetNetDevice (i));
           socket->Bind (local);
-          socket->ShutdownRecv ();
+          socket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
           socket->SetIpv6RecvHopLimit (true);
-          m_sendSocketList[socket] = i;
+          socket->SetRecvPktInfo (true);
+          m_unicastSocketList[socket] = i;
         }
       else if (address.GetScope() == Ipv6InterfaceAddress::GLOBAL)
         {
@@ -326,17 +328,17 @@
         }
     }
 
-  if (!m_recvSocket)
+  if (!m_multicastRecvSocket)
     {
       NS_LOG_LOGIC ("RIPng: adding receiving socket");
       TypeId tid = TypeId::LookupByName ("ns3::UdpSocketFactory");
       Ptr<Node> theNode = GetObject<Node> ();
-      m_recvSocket = Socket::CreateSocket (theNode, tid);
+      m_multicastRecvSocket = Socket::CreateSocket (theNode, tid);
       Inet6SocketAddress local = Inet6SocketAddress (RIPNG_ALL_NODE, RIPNG_PORT);
-      m_recvSocket->Bind (local);
-      m_recvSocket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
-      m_recvSocket->SetIpv6RecvHopLimit (true);
-      m_recvSocket->SetRecvPktInfo (true);
+      m_multicastRecvSocket->Bind (local);
+      m_multicastRecvSocket->SetRecvCallback (MakeCallback (&RipNg::Receive, this));
+      m_multicastRecvSocket->SetIpv6RecvHopLimit (true);
+      m_multicastRecvSocket->SetRecvPktInfo (true);
     }
 }
 
@@ -353,14 +355,14 @@
         }
     }
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       NS_LOG_INFO ("Checking socket for interface " << interface);
       if (iter->second == interface)
         {
           NS_LOG_INFO ("Removed socket for interface " << interface);
           iter->first->Close ();
-          m_sendSocketList.erase (iter);
+          m_unicastSocketList.erase (iter);
           break;
         }
     }
@@ -538,14 +540,14 @@
   m_nextTriggeredUpdate = EventId ();
   m_nextUnsolicitedUpdate = EventId ();
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       iter->first->Close ();
     }
-  m_sendSocketList.clear ();
+  m_unicastSocketList.clear ();
 
-  m_recvSocket->Close ();
-  m_recvSocket = 0;
+  m_multicastRecvSocket->Close ();
+  m_multicastRecvSocket = 0;
 
   m_ipv6 = 0;
 
@@ -777,7 +779,7 @@
               // we use one of the sending sockets, as they're bound to the right interface
               // and the local address might be used on different interfaces.
               Ptr<Socket> sendingSocket;
-              for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+              for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
                 {
                   if (iter->second == incomingInterface)
                     {
@@ -857,7 +859,7 @@
       Ptr<Socket> sendingSocket;
       if (senderAddress.IsLinkLocal ())
         {
-          for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+          for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
             {
               if (iter->second == incomingInterface)
                 {
@@ -867,7 +869,7 @@
         }
       else
         {
-          sendingSocket = m_recvSocket;
+          sendingSocket = m_multicastRecvSocket;
         }
 
       Ptr<Packet> p = Create<Packet> ();
@@ -1078,7 +1080,7 @@
 {
   NS_LOG_FUNCTION (this << (periodic ? " periodic" : " triggered"));
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       uint32_t interface = iter->second;
 
@@ -1254,7 +1256,7 @@
   hdr.AddRte (rte);
   p->AddHeader (hdr);
 
-  for (SocketListI iter = m_sendSocketList.begin (); iter != m_sendSocketList.end (); iter++ )
+  for (SocketListI iter = m_unicastSocketList.begin (); iter != m_unicastSocketList.end (); iter++ )
     {
       uint32_t interface = iter->second;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ripng.h ns-3.31/src/internet/model/ripng.h
--- ns-3.30.1/src/internet/model/ripng.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ripng.h	2020-06-27 17:38:30.000000000 -0700
@@ -395,8 +395,8 @@
   /// Socket list type const iterator
   typedef std::map<Ptr<Socket>, uint32_t>::const_iterator SocketListCI;
 
-  SocketList m_sendSocketList; //!< list of sockets for sending (socket, interface index)
-  Ptr<Socket> m_recvSocket; //!< receive socket
+  SocketList m_unicastSocketList; //!< list of sockets for unicast messages (socket, interface index)
+  Ptr<Socket> m_multicastRecvSocket; //!< multicast receive socket
 
   EventId m_nextUnsolicitedUpdate; //!< Next Unsolicited Update event
   EventId m_nextTriggeredUpdate; //!< Next Triggered Update event
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-bic.cc ns-3.31/src/internet/model/tcp-bic.cc
--- ns-3.30.1/src/internet/model/tcp-bic.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-bic.cc	2020-06-27 17:38:30.000000000 -0700
@@ -273,6 +273,14 @@
   return ssThresh;
 }
 
+void
+TcpBic::ReduceCwnd (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+
+  tcb->m_cWnd = std::max (tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
+}
+
 Ptr<TcpCongestionOps>
 TcpBic::Fork (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-bic.h ns-3.31/src/internet/model/tcp-bic.h
--- ns-3.30.1/src/internet/model/tcp-bic.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-bic.h	2020-06-27 17:38:30.000000000 -0700
@@ -103,6 +103,7 @@
                                uint32_t segmentsAcked);
   virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
                                 uint32_t bytesInFlight);
+  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
 
   virtual Ptr<TcpCongestionOps> Fork ();
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-congestion-ops.cc ns-3.31/src/internet/model/tcp-congestion-ops.cc
--- ns-3.30.1/src/internet/model/tcp-congestion-ops.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-congestion-ops.cc	2020-06-27 17:38:30.000000000 -0700
@@ -17,7 +17,6 @@
  *
  */
 #include "tcp-congestion-ops.h"
-#include "tcp-socket-base.h"
 #include "ns3/log.h"
 
 namespace ns3 {
@@ -48,6 +47,48 @@
 {
 }
 
+void
+TcpCongestionOps::IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked);
+}
+
+void
+TcpCongestionOps::PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
+                             const Time& rtt)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked << rtt);
+}
+
+void
+TcpCongestionOps::CongestionStateSet (Ptr<TcpSocketState> tcb,
+                                      const TcpSocketState::TcpCongState_t newState)
+{
+  NS_LOG_FUNCTION (this << tcb << newState);
+}
+
+void
+TcpCongestionOps::CwndEvent (Ptr<TcpSocketState> tcb,
+                             const TcpSocketState::TcpCAEvent_t event)
+{
+  NS_LOG_FUNCTION (this << tcb << event);
+}
+
+bool
+TcpCongestionOps::HasCongControl () const
+{
+  return false;
+}
+
+void
+TcpCongestionOps::CongControl (Ptr<TcpSocketState> tcb,
+                               const TcpRateOps::TcpRateConnection &rc,
+                               const TcpRateOps::TcpRateSample &rs)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  NS_UNUSED (rc);
+  NS_UNUSED (rs);
+}
 
 // RENO
 
@@ -209,6 +250,14 @@
   return std::max (2 * state->m_segmentSize, bytesInFlight / 2);
 }
 
+void
+TcpNewReno::ReduceCwnd (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+
+  tcb->m_cWnd = std::max (tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
+}
+
 Ptr<TcpCongestionOps>
 TcpNewReno::Fork ()
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-congestion-ops.h ns-3.31/src/internet/model/tcp-congestion-ops.h
--- ns-3.30.1/src/internet/model/tcp-congestion-ops.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-congestion-ops.h	2020-06-27 17:38:30.000000000 -0700
@@ -19,7 +19,8 @@
 #ifndef TCPCONGESTIONOPS_H
 #define TCPCONGESTIONOPS_H
 
-#include "ns3/tcp-socket-state.h"
+#include "tcp-rate-ops.h"
+#include "tcp-socket-state.h"
 
 namespace ns3 {
 
@@ -35,13 +36,13 @@
  *
  * \brief Congestion control abstract class
  *
- * The design is inspired on what Linux v4.0 does (but it has been
- * in place since years). The congestion control is split from the main
+ * The design is inspired by what Linux v4.0 does (but it has been
+ * in place for years). The congestion control is split from the main
  * socket code, and it is a pluggable component. An interface has been defined;
  * variables are maintained in the TcpSocketState class, while subclasses of
  * TcpCongestionOps operate over an instance of that class.
  *
- * Only three methods has been utilized right now; however, Linux has many others,
+ * Only three methods have been implemented right now; however, Linux has many others,
  * which can be added later in ns-3.
  *
  * \see IncreaseWindow
@@ -74,9 +75,19 @@
   virtual std::string GetName () const = 0;
 
   /**
+   * \brief Set configuration required by congestion control algorithm
+   *
+   * \param tcb internal congestion state
+   */
+  virtual void Init (Ptr<TcpSocketState> tcb)
+    {
+      NS_UNUSED (tcb);
+    }
+
+  /**
    * \brief Get the slow start threshold after a loss event
    *
-   * Is guaranteed that the congestion control state (TcpAckState_t) is
+   * Is guaranteed that the congestion control state (\p TcpAckState_t) is
    * changed BEFORE the invocation of this method.
    * The implementator should return the slow start threshold (and not change
    * it directly) because, in the future, the TCP implementation may require to
@@ -93,22 +104,22 @@
   /**
    * \brief Congestion avoidance algorithm implementation
    *
-   * Mimic the function cong_avoid in Linux. New segments have been ACKed,
-   * and the congestion control duty is to set
+   * Mimic the function \pname{cong_avoid} in Linux. New segments have been ACKed,
+   * and the congestion control duty is to update the window.
    *
    * The function is allowed to change directly cWnd and/or ssThresh.
    *
    * \param tcb internal congestion state
    * \param segmentsAcked count of segments acked
    */
-  virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked) = 0;
+  virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
 
   /**
    * \brief Timing information on received ACK
    *
    * The function is called every time an ACK is received (only one time
    * also for cumulative ACKs) and contains timing information. It is
-   * optional (congestion controls can not implement it) and the default
+   * optional (congestion controls need not implement it) and the default
    * implementation does nothing.
    *
    * \param tcb internal congestion state
@@ -116,53 +127,84 @@
    * \param rtt last rtt
    */
   virtual void PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
-                          const Time& rtt)
-  {
-    NS_UNUSED (tcb);
-    NS_UNUSED (segmentsAcked);
-    NS_UNUSED (rtt);
-  }
+                          const Time& rtt);
 
   /**
    * \brief Trigger events/calculations specific to a congestion state
    *
-   * This function mimics the function set_state in Linux.
-   * The function is called before changing congestion state.
+   * This function mimics the notification function \pname{set_state} in Linux.
+   * The function does not change the congestion state in the tcb; it notifies
+   * the congestion control algorithm that this state is about to be changed.
+   * The tcb->m_congState variable must be separately set; for example:
+   *
+   * \code
+   *   m_congestionControl->CongestionStateSet (m_tcb, TcpSocketState::CA_RECOVERY);
+   *   m_tcb->m_congState = TcpSocketState::CA_RECOVERY;
+   * \endcode
    *
    * \param tcb internal congestion state
    * \param newState new congestion state to which the TCP is going to switch
    */
   virtual void CongestionStateSet (Ptr<TcpSocketState> tcb,
-                                   const TcpSocketState::TcpCongState_t newState)
-  {
-    NS_UNUSED (tcb);
-    NS_UNUSED (newState);
-  }
+                                   const TcpSocketState::TcpCongState_t newState);
 
   /**
-   * \brief Trigger events/calculations on occurrence congestion window event
+   * \brief Trigger events/calculations on occurrence of congestion window event
    *
-   * This function mimics the function cwnd_event in Linux.
+   * This function mimics the function \pname{cwnd_event} in Linux.
    * The function is called in case of congestion window events.
    *
    * \param tcb internal congestion state
    * \param event the event which triggered this function
    */
   virtual void CwndEvent (Ptr<TcpSocketState> tcb,
-                          const TcpSocketState::TcpCAEvent_t event)
-  {
-    NS_UNUSED (tcb);
-    NS_UNUSED (event);
-  }
+                          const TcpSocketState::TcpCAEvent_t event);
+
+  /**
+   * \brief Returns true when Congestion Control Algorithm implements CongControl
+   *
+   * \return true if CC implements CongControl function
+   *
+   * This function is the equivalent in C++ of the C checks that are used
+   * in the Linux kernel to see if an optional function has been defined.
+   * Since CongControl is optional, not all congestion controls have it. But,
+   * from the perspective of TcpSocketBase, the behavior is different if
+   * CongControl is present. Therefore, this check should return true for any
+   * congestion controls that implements the CongControl optional function.
+   */
+  virtual bool HasCongControl () const;
+
+  /**
+   * \brief Called when packets are delivered to update cwnd and pacing rate
+   *
+   * This function mimics the function cong_control in Linux. It is allowed to
+   * change directly cWnd and pacing rate.
+   *
+   * \param tcb internal congestion state
+   * \param rc Rate information for the connection
+   * \param rs Rate sample (over a period of time) information
+   */
+  virtual void CongControl (Ptr<TcpSocketState> tcb,
+                            const TcpRateOps::TcpRateConnection &rc,
+                            const TcpRateOps::TcpRateSample &rs);
+
+  /**
+   * \brief Reduces congestion window on receipt of ECN Echo Flag
+   *
+   * \param tcb internal congestion state
+   */
+  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb) = 0;
+
   // Present in Linux but not in ns-3 yet:
   /* call when ack arrives (optional) */
-  // void (*in_ack_event)(struct sock *sk, u32 flags);
+  //     void (*in_ack_event)(struct sock *sk, u32 flags);
   /* new value of cwnd after loss (optional) */
-  // u32  (*undo_cwnd)(struct sock *sk);
+  //     u32  (*undo_cwnd)(struct sock *sk);
   /* hook for packet ack accounting (optional) */
+  //     void (*pkts_acked)(struct sock *sk, u32 ext, int *attr, union tcp_cc_info *info);
 
   /**
-   * \brief Copy the congestion control algorithm across socket
+   * \brief Copy the congestion control algorithm across sockets
    *
    * \return a pointer of the copied object
    */
@@ -201,7 +243,7 @@
   virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
   virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
                                 uint32_t bytesInFlight);
-
+  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
   virtual Ptr<TcpCongestionOps> Fork ();
 
 protected:
